from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, File, String

Hisat2_Build_L_V0_1_0 = CommandToolBuilder(tool="hisat2_build_l", base_command=["hisat2-build-l"], inputs=[ToolInput(tag="in_reference_sequences_given", input_type=Boolean(optional=True), prefix="-c", doc=InputDocumentation(doc="reference sequences given on cmd line (as\n<reference_in>)")), ToolInput(tag="in_no_auto", input_type=Boolean(optional=True), prefix="--noauto", doc=InputDocumentation(doc="disable automatic -p/--bmax/--dcv memory-fitting")), ToolInput(tag="in_number_of_threads", input_type=Int(optional=True), prefix="-p", doc=InputDocumentation(doc="number of threads")), ToolInput(tag="in_bmax", input_type=Int(optional=True), prefix="--bmax", doc=InputDocumentation(doc="max bucket sz for blockwise suffix-array builder")), ToolInput(tag="in_bmax_divn", input_type=Int(optional=True), prefix="--bmaxdivn", doc=InputDocumentation(doc="max bucket sz as divisor of ref len (default: 4)")), ToolInput(tag="in_dcv", input_type=Int(optional=True), prefix="--dcv", doc=InputDocumentation(doc="diff-cover period for blockwise (default: 1024)")), ToolInput(tag="in_no_dc", input_type=Boolean(optional=True), prefix="--nodc", doc=InputDocumentation(doc="disable diff-cover (algorithm becomes quadratic)")), ToolInput(tag="in_no_ref", input_type=Boolean(optional=True), prefix="--noref", doc=InputDocumentation(doc="don't build .3/.4.ht2 (packed reference) portion")), ToolInput(tag="in_just_ref", input_type=Boolean(optional=True), prefix="--justref", doc=InputDocumentation(doc="just build .3/.4.ht2 (packed reference) portion")), ToolInput(tag="in_off_rate", input_type=Int(optional=True), prefix="--offrate", doc=InputDocumentation(doc="SA is sampled every 2^offRate BWT chars (default: 5)")), ToolInput(tag="in_f_tab_chars", input_type=Int(optional=True), prefix="--ftabchars", doc=InputDocumentation(doc="# of chars consumed in initial lookup (default: 10)")), ToolInput(tag="in_local_off_rate", input_type=Int(optional=True), prefix="--localoffrate", doc=InputDocumentation(doc="SA (local) is sampled every 2^offRate BWT chars (default: 3)")), ToolInput(tag="in_local_f_tab_chars", input_type=Int(optional=True), prefix="--localftabchars", doc=InputDocumentation(doc="# of chars consumed in initial lookup in a local index (default: 6)")), ToolInput(tag="in_snp", input_type=File(optional=True), prefix="--snp", doc=InputDocumentation(doc="SNP file name")), ToolInput(tag="in_haplotype", input_type=File(optional=True), prefix="--haplotype", doc=InputDocumentation(doc="haplotype file name")), ToolInput(tag="in_ss", input_type=File(optional=True), prefix="--ss", doc=InputDocumentation(doc="Splice site file name")), ToolInput(tag="in_exon", input_type=File(optional=True), prefix="--exon", doc=InputDocumentation(doc="Exon file name")), ToolInput(tag="in_repeat_ref", input_type=File(optional=True), prefix="--repeat-ref", doc=InputDocumentation(doc="Repeat reference file name")), ToolInput(tag="in_repeat_info", input_type=File(optional=True), prefix="--repeat-info", doc=InputDocumentation(doc="Repeat information file name")), ToolInput(tag="in_repeat_snp", input_type=File(optional=True), prefix="--repeat-snp", doc=InputDocumentation(doc="Repeat snp file name")), ToolInput(tag="in_repeat_haplotype", input_type=File(optional=True), prefix="--repeat-haplotype", doc=InputDocumentation(doc="Repeat haplotype file name")), ToolInput(tag="in_seed", input_type=Int(optional=True), prefix="--seed", doc=InputDocumentation(doc="seed for random number generator")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="disable verbose output (for debugging)")), ToolInput(tag="in_reference_in", input_type=String(), position=0, doc=InputDocumentation(doc="comma-separated list of files with ref sequences")), ToolInput(tag="in_his_at_two_index_base", input_type=Int(), position=1, doc=InputDocumentation(doc="write ht2l data to files with this dir/basename"))], outputs=[], container="quay.io/biocontainers/hisat2:2.2.1--he1b5a44_1", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Hisat2_Build_L_V0_1_0().translate("wdl")

